% _____________________________________________
% Vorlesung Biomechanik:
% Musterlsung der 2. bungsaufgabe
% _____________________________________________
% Filip Cengic, November 2012

close all
clear all
clc

%% Initialisierung
g = 9.81;                   % Erdanziehungsbeschleunigung
dt = 0.1;                % Zeitabschnitte
t_max = 1000;               % Festlegung der Iterationen (Anzahl Schleifendruchlufe) ohne LW


time = 0:dt:t_max;       % Array fr Zeitschritte (x-Achse) - Ohne Luftwiderstandskraft
s = zeros(length(time),1);  % Array zum Speichern der Daten des Weges
v = zeros(length(time),1);  % Array zum Speichern der Daten der Geschwindigkeit
a = zeros(length(time),1);  % Array zum Speichern der Daten des Beschleunigungsverlaufs

a(1) = g;                   % Beschleunigung betrgt zu Beginn 9,81 m/s^2


%% Ohne Luftwiderstand

for i=2:length(time)            % for-Schleife > Durchlufe: Anzahl entspricht Anzahl der Elemente des 'time'-Arrays
    a(i) = g;                   % schreibt Wert an i-te Position der Variable (hier 'a')
    v(i) = v(i-1)+a(i)*dt;   % erhht Wert von V(i-1) um aktuellen Wert a(i)*dt (Zeitschritt '0.1')
    s(i) = s(i-1)+v(i)*dt;   % erhht Wert von s(i-1) um aktuellen Wert v(i)*dt (Zeitschritt '0.1')
    if (s(i) >= 39000)          % Abbruchkriterium fr for-Schleife wenn Weg (s) grer/gleich 39000m
        t_max = i * dt;      % Berechnet Flugdauer anhand Schleifendurchlufen
        time = 1:dt:t_max;   % berschreibt 'time' mit aktuellen Werten (optional) --> fr grafische Darstellung
        break;                  % beendet die for-Schleife
    end;
end;

% Initialisierung von Hilfsvariablen zur Ertellung der grafischen Ausgabe (optional)
s_graph = s(1:length(time))/1000;   % herunterskalieren der Werte fr s --> hier braucht man nur 1 Koordinatensystem
v_graph = v(1:length(time))/1000;   % herunterskalieren der Werte fr v
a_graph = a(1:length(time));

% dies ist eine selbstertellte Funktion zur Erstellung des Graphen > Code
% wurde in andere Datei ausgelagert
matlab02_graph(121, time, s_graph, v_graph, a_graph, ...
    'Ohne Luftwiderstand');


%% Mit Luftwiderstandskraft

% Initialisierung der neuen Variablen
t_max_luft = 10000;                 % Festlegung der Iterationen (Anzahl der Schleifendurchlufe) mit LW
time_luft = 1:dt:t_max_luft;     % Array fr Zeitschritte (x-Achse)
m = 100;                            % def > Masse
dichte = 1;                         % def > Luftdichte
flaeche = 0.25;                     % def > Krperflche
cW = 1.1;                           % def > Formwiderstand

c = 0.5 * dichte * flaeche * cW;    % Zusamemnfassen von unvernderlichen Variablen zu einer Konstanten

s_luft = zeros(length(time_luft),1);    % Array zum Speichern der Werte des Weges 
v_luft = zeros(length(time_luft),1);    % Array zum Speichern der Werte der Geschwindigkeit
a_luft = zeros(length(time_luft),1);    % Array zum Speichern der Werte der Beschleunigung

a_luft(1) = g;                          % def > Beschleunigung


for i=2:length(time_luft)               % for-Schleife > Durchlufe: Anzahl entspricht Anzahl der Elemente des 'time'-Arrays 
    a_luft(i) = g - c * power(v_luft(i-1),2)/m;     % speichert Wert fr 'a' an i-ter Stelle ab
    v_luft(i) = v_luft(i-1) + dt * a_luft(i);    % speichert Wert fr 'v' an i-ter Stelle ab
    s_luft(i) = s_luft(i-1) + dt * v_luft(i);    % speichert Wert fr 's' an i-ter Stelle ab
            
    if (s_luft(i) >= 39000)                         % Abbruchkriterium fr for-Schleife
        t_max_luft = i * dt;                     % Berechnung fr Flugdauer
        time_luft = 1:dt:t_max_luft;             % berschreibt 'time' mit aktuellen Werten (optional) --> fr grafische Darstellung
        break;                                      % beendet die for-Schleife
    end;
    
end;

% Initialisierung von Hilfsvariablen zur Ertellung der grafischen Ausgabe (optional)
s_luft = s_luft(1:length(time_luft))/1000; % herunterskalieren der Wert fr 's'
v_luft = v_luft(1:length(time_luft))/1000; % herunterskalieren der Werte fr 'v' 
a_luft = a_luft(1:length(time_luft));

% dies ist eine selbstertellte Funktion zur Erstellung des Graphen > Code
% wurde in andere Datei ausgelagert
matlab02_graph(122, time_luft, s_luft, v_luft, a_luft, ...
    'Mit Luftwiderstand');


